std::get(std::array)(3)

NAME
std::get(std::array) - std::get(std::array)

Synopsis
   Defined in header <array>
   template< std::size_t I, class T, std::size_t N > (1) (since C++11)
   T& get( std::array<T,N>& a ) noexcept; (constexpr since C++14)
   template< std::size_t I, class T, std::size_t N > (2) (since C++11)
   T&& get( std::array<T,N>&& a ) noexcept; (constexpr since C++14)
   template< std::size_t I, class T, std::size_t N > (3) (since C++11)
   const T& get( const std::array<T,N>& a ) noexcept; (constexpr since C++14)
   template< std::size_t I, class T, std::size_t N > (4) (since C++11)
   const T&& get( const std::array<T,N>&& a ) noexcept; (constexpr since C++14)
   Extracts the I^th element from the array using tuple-like interface.
   I must be an integer value in range [0, N). This is enforced at compile time as
   opposed to at() or operator[].

Parameters
   a - array whose contents to extract

Return value
   A reference to the I^th element of a.

Complexity
   Constant.

Example
// Run this code
 #include <array>
 #include <iostream>
 constexpr std::array v{1, 2, 3};
 static_assert(get<0>(v) == 1 && get<1>(v) == 2 && get<2>(v) == 3);
 int main()
 {
     std::array<int, 3> a;
     // set values:
     get<0>(a) = 1, get<1>(a) = 2, get<2>(a) = 3;
     // get values:
     std::cout << '(' << get<0>(a) << ',' << get<1>(a) << ',' << get<2>(a) << ")\n";
 }

Output:
 (1,2,3)
   Defect reports
   The following behavior-changing defect reports were applied retroactively to
   previously published C++ standards.
      DR Applied to Behavior as published Correct behavior
   LWG 2485 C++11 there are no overloads for const array&& the overloads are added

See also
   Structured binding (C++17) binds the specified names to sub-objects or tuple
                        elements of the initializer
   operator[] access specified element
                        (public member function)
   at access specified element with bounds checking
                        (public member function)
   get(std::tuple) tuple accesses specified element
   (C++11) (function template)
   get(std::pair) accesses an element of a pair
   (C++11) (function template)
   get(std::variant) reads the value of the variant given the index or the
   (C++17) type (if the type is unique), throws on error
                        (function template)
   get(std::ranges::subrange) obtains iterator or sentinel from a std::ranges::subrange
   (C++20) (function template)